



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>WPF实现毛玻璃效果</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">WPF实现毛玻璃效果</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 14:32:01 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>1和2需要Microsoft.WindowsAPICodePack.Shell.dll 和引用using System.Windows.Interop，并只能在有DwmApi.dll 版本的Windows操作系统下使用。这两种方法的共同缺点是：在启动窗体时会一闪。</p>
<p>一、</p>
<div>
<pre class="prettyprint linenums"> [StructLayout(LayoutKind.Sequential)]<br />
        public struct MARGINS<br />
        {<br />
            public int cxLeftWidth;<br />
            public int cxRightWidth;<br />
            public int cyTopHeight;<br />
            public int cyBottomHeight;<br />
        };

        [DllImport("DwmApi.dll")]<br />
        public static extern int DwmExtendFrameIntoClientArea(<br />
            IntPtr hwnd,<br />
            ref MARGINS pMarInset);

        private void ExtendAeroGlass(Window window)<br />
        {<br />
            try<br />
            {<br />
                // 为WPF程序获取窗口句柄<br />
                IntPtr mainWindowPtr = new WindowInteropHelper(window).Handle;<br />
                HwndSource mainWindowSrc = HwndSource.FromHwnd(mainWindowPtr);<br />
                mainWindowSrc.CompositionTarget.BackgroundColor = Colors.Transparent;

                // 设置Margins<br />
                MARGINS margins = new MARGINS();

                // 扩展Aero Glass<br />
                margins.cxLeftWidth = -;<br />
                margins.cxRightWidth = -;<br />
                margins.cyTopHeight = -;<br />
                margins.cyBottomHeight = -;

                int hr = DwmExtendFrameIntoClientArea(mainWindowSrc.Handle, ref margins);<br />
                if (hr &lt; )<br />
                {<br />
                    MessageBox.Show("DwmExtendFrameIntoClientArea Failed");<br />
                }<br />
            }<br />
            catch (DllNotFoundException)<br />
            {<br />
                Application.Current.MainWindow.Background = Brushes.White;<br />
            }<br />
        }<br />
        private void Window_Loaded(object sender, RoutedEventArgs e)<br />
        {<br />
            this.Background = Brushes.Transparent;<br />
            ExtendAeroGlass(this);<br />
        }</pre>
</div>
<p>二、</p>
<div>
<pre class="prettyprint linenums">[StructLayout(LayoutKind.Sequential)]<br />
public struct MARGINS<br />
{<br />
    public MARGINS(Thickness t)<br />
    {<br />
        Left = (int)t.Left;<br />
        Right = (int)t.Right;<br />
        Top = (int)t.Top;<br />
        Bottom = (int)t.Bottom;<br />
    }<br />
    public int Left;<br />
    public int Right;<br />
    public int Top;<br />
    public int Bottom;<br />
}

public class GlassHelper<br />
{<br />
    [DllImport("dwmapi.dll", PreserveSig = false)]<br />
    static extern void DwmExtendFrameIntoClientArea(<br />
        IntPtr hWnd, ref MARGINS pMarInset);<br />
    [DllImport("dwmapi.dll", PreserveSig = false)]<br />
        static extern bool DwmIsCompositionEnabled();

    public static bool ExtendGlassFrame(Window window, Thickness margin)<br />
    {<br />
        if (!DwmIsCompositionEnabled())<br />
            return false;

        IntPtr hwnd = new WindowInteropHelper(window).Handle;<br />
        if (hwnd == IntPtr.Zero)<br />
            throw new InvalidOperationException(<br />
            "The Window must be shown before extending glass.");

        // Set the background to transparent from both the WPF and Win32 perspectives<br />
        window.Background = Brushes.Transparent;<br />
        HwndSource.FromHwnd(hwnd).CompositionTarget.BackgroundColor = Colors.Transparent;

        MARGINS margins = new MARGINS(margin);<br />
        DwmExtendFrameIntoClientArea(hwnd, ref margins);<br />
        return true;<br />
    }<br />
}

        protected override void OnSourceInitialized(EventArgs e)<br />
        {<br />
            base.OnSourceInitialized(e);<br />
            GlassHelper.ExtendGlassFrame(this, new Thickness(-));<br />
        }</pre>
</div>
<p>三、</p>
<p>这个方法 需要Microsoft.Windows.Shell.dll&nbsp;&nbsp; 没有一闪的缺陷！</p>
<div>
<pre class="prettyprint linenums"> xmlns:shell="clr-namespace:Microsoft.Windows.Shell;assembly=Microsoft.Windows.Shell"</pre>
</div>
<div>
<pre class="prettyprint linenums">&lt;shell:WindowChrome.WindowChrome&gt;<br />
        &lt;shell:WindowChrome GlassFrameThickness="-1" ResizeBorderThickness=""<br />
                            CaptionHeight="" CornerRadius="" /&gt;<br />
    &lt;/shell:WindowChrome.WindowChrome&gt;</pre>
</div>
<div>
<pre class="prettyprint linenums">    &lt;Window.Template&gt;<br />
        &lt;ControlTemplate TargetType="{x:Type Window}"&gt;<br />
            &lt;Border BorderThickness=""&gt;<br />
                &lt;DockPanel&gt;<br />
                    &lt;Grid x:Name="WindowHeader" DockPanel.Dock="Top" Height=""&gt;<br />
                        &lt;TextBlock Text="{TemplateBinding Title}"/&gt;<br />
                    &lt;/Grid&gt;<br />
                    &lt;ContentPresenter Margin="5,5,5,5"/&gt;<br />
                &lt;/DockPanel&gt;<br />
            &lt;/Border&gt;<br />
        &lt;/ControlTemplate&gt;<br />
    &lt;/Window.Template&gt;</pre>
</div>
<p>转载地址：http://blog.csdn.net/kingscrown/article/details/7771094</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8okdex9.html">mysql初级命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qn16r28.html">OS命令注入中的空格</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pmv1k9.html">iOS 应用数据存储方式（XML属性列表-plist）</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jegn48.html">SQL语句汇总</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qy5ko29.html">Best Practices for Performance&lowbar;3&period;Improving Layout Performance  优化布局</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jynoe9.html">一看就懂的Android APP开发入门教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/m966ez39.html">ios runtime swizzle</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdez42j9.html">TCP和UDP协议的应用&sol;参数查看</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1ex559.html">java&lpar;try块语句变量，和匿名类变量生存时间</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z1n329.html">《Programming WPF》翻译 第7章 5&period;可视化层编程</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zol4x9.html">通过Web Api 和 Angular&period;js 构建单页面的web 程序</a>
		</li>
						<li><a href="https://www.batexi.com/a/95034ov8.html">Codeforces Round &num;366 &lpar;Div&period; 2&rpar;&lowbar;C&period; Thor</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjnldr8.html">&lbrack;2015-11-23&rsqb;分享一个批处理脚本，创建iis站点及程序池</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1m46yq.html">PAT1070&colon;Mooncake</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyood19.html">学习excel的使用技巧复制一列文本成新列去重</a>
		</li>
						<li><a href="https://www.batexi.com/a/960gxrv9.html">Centos7安装Zabbix4&period;0步骤</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jmjoxl9.html">BackBone及其实例探究</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkkl6v8.html">WinForm窗体继承</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rn0p2rq.html">初学者必读之AJAX简单实例2</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vlje4q.html">angular 使用服务共享数据需要注意</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qde7lwj9.html">&lbrack;TYVJ&rsqb; P1017 冗余关系</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gmo0g79.html">DDP和DDU什么区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydz3rxq.html">libeXosip2&lpar;1-3&rpar; -- How-To send or update registrations&period;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1z1x029.html">Compiled Language vs Scripting Language</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4yl1r0q.html">Copy Constructor in Java</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gmovg09.html">《Algorithms 4th Edition》读书笔记&mdash;&mdash;3&period;1 符号表&lpar;Elementary Symbol Tables&rpar;-Ⅱ</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gmow079.html">Java单元测试：&commat;BeforeClass，&commat;Before，&commat;Test，&commat;After，&commat;AfterClass中的问题详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4yl0o5q.html">数据库中简单的增删改查（CRUD）</a>
			</li>
						<li><a href="https://www.batexi.com/a/96ove149.html">java删除文件夹下所有文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1xx2r9.html">LeetCode&colon; Longest Consecutive Sequence &lbrack;128&rsqb;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
